!function(){
/*!
	loader.get('')
	name:
		module		by ajax
		image		by image
		script		by script
		text		by ajax
		
		eg:
			text!http://www.baidu.com/texts/demo
			image!http://www.baidu.com/texts/demo
			http://www.baidu.com/texts/demo
			jquery!http://baidu.com/jquery.js
			
		auto get  type by extname
			text: ['txt', 'html', 'css']
			image: ['jpg', 'png', 'gif', 'jpeg', 'webp']
*/
	
	function Loader(op){
		this.amd = true;
		this._alias = {};
		this._cache = {};
		this._loadings = {};
		this.option = {
			root: ''
			, sep: '!'
			, suffix: '.js'
			, beforeGet: null
			, beforeLoad: null
		};
		
		this._init(op);
	}
	
	
	Loader.prototype.varsion = '1.0.0';
	
	
	/**
	 * init metho
	 * @param {object} op - option
	 * @return {this}
	 */
	Loader.prototype._init = function(op){
		var option = this.option
		, key
		;
		op = op || {};
		
		for(key in op){
			if(op[key] != null) option[key] = op[key];
		}
	
		return this;
	}
	
	
	/**
	 * alias module name
	 * @param {object} o - alias module name map, alias name: true name
	 * @return {undefined}
	 */
	Loader.prototype.alias = function(o){
		var alias = this._alias
		;
		each(o, function(value, key){
			alias[key] = value;
		});
	};
	
	
	/**
	 * get module
	 * @param {string|array<object>} [requires=[]] - module requires list
	 * @param {function} fn - module name
	 * @return {undefined}
	 */
	Loader.prototype.get = function(requires, fn){
		if(typeof requires === 'function'){
			fn = requires;
			requires = [];
		}else{
			requires = typeOf(requires) === 'array' ? requires : [requires]
		}
		
		this._getRequires(requires, function(list){
			fnCall(fn, list);
		});
	};
	
	
	/**
	 * get a module generator
	 * @param {object} item - module generator config
	 * @param {string} item.name - module name
	 * @param {string} item.type - module type
	 * @param {object} item.object - module result
	 * @param {array<object>} item.requires - module requires list
	 * @return {undefined}
	 */
	Loader.prototype._getItem = function(name, fn){
		var self = this
		, cache = this._cache
		, alias = this._alias
		, option = this.option
		, item, rs
		;
		name = alias[name] != null ? alias[name] : name;
		name = name == null ? '' : name.toString();
		
		//* get object or name from beforeGet method
		item = fnCall(option.beforeGet, [name]);
		if(item){
			if(typeof item === 'string'){
				name = item;
				item = null;
			}else{
				item = {object: item};
			}
		}
		
		//* get from cache
		if(!item){
			item = cache[name];
		}
		
		//* get object or create from module
		if(!item){
			this._loadItem(name, function(rs){
				item = rs;
				getObject();
			});
		}else{
			getObject();
		}
		
		function getObject(){
			if(typeof item.generator === 'function'){
				self._getRequires(item.requires, function(list){
					rs = item.generator.apply(null, list);
					callback();
				});
			}else{
				rs = item.object;
				callback();
			}
		}
		
		function callback(){
			fnCall(fn, [rs]);
		}
	};
	
	
	/**
	 * get modules
	 * @param {array<string>} requires - module name list
	 * @param {function} fn - callback
	 * @return {undefined}
	 */
	Loader.prototype._getRequires = function(requires, fn){
		var self = this
		, list = []
		, i
		;
		if(requires.length === 0){
			callback();
		}else{
			for(i = 0; i < requires.length; i++) list.push(Infinity);
			each(requires, function(name, i){
				self._getItem(name, function(rs){
					list[i] = rs;
					if(list.indexOf(Infinity) === -1){
						callback();
					}
				});
			});
		}
		
		function callback(){
			fnCall(fn, [list]);
		}
	};
	
	
	/**
	 * set module generator
	 * @param {string} [name] - module requires list
	 * @param {array<string>} [requires] - module name requires list
	 * @param {function|object} fn - module generator or object
	 * @param {object} [option]
	 * @return {undefined}
	 */
	Loader.prototype.set = function(){
		var item = this._parseItem.apply(this, arguments)
		;
		this._setItem(item);
	};
	
	
	/**
	 * add a module generator
	 * @param {object} item - module generator config
	 * @param {string} item.name - module name
	 * @param {object} item.object - module result
	 * @param {array<object>} item.requires - module requires list
	 * @param {function} item.generator - module generator
	 * @param {string} item.type - module type
	 * @return {undefined}
	 */
	Loader.prototype._setItem = function(item, name){
		var cache = this._cache
		;
		name = name != null ? name : item.name;
		cache[name] = item;
	};
	
	
	/**
	 * add a module generator
	 * @param {object} item - module generator config
	 * @param {string} item.name - module name
	 * @param {object} item.object - module result
	 * @param {array<object>} item.requires - module requires list
	 * @param {function} item.generator - module generator
	 * @param {string} item.type - module type
	 * @return {undefined}
	 */
	Loader.prototype._parseItem = function(){
		var item = {
			type: 'module'
			, name: null
			, generator: null
			, object: null
			, requires: []
			, option: {}
		}
		, key
		;
		each(arguments, function(arg, i){
			switch(typeOf(arg)){
				case 'string':
					item.name = arg;
					
				break; case 'array':
					item.requires = arg;
					
				break; case 'object':
					if(i === arguments.length - 1 && (item.object || item.generator)){		
						if(arg){
							for(key in arg){
								if(arg[key] != null) item.option[key] = arg[key];
							}
						}
					}else{
						item.object = arg;
					}
					
				break; case 'function':
					item.generator = arg;
			}
		});
		
		item.name = item.name != null ?  item.name : (this.__moduleName__ || '');
		
		return item;
	};
	
	
	/**
	 * load module item
	 * @param {string} name - module name
	 * @param {function} fn - callback
	 * @return {undefined}
	 */
	Loader.prototype._loadItem = function(name, fn){
		var self = this
		, loadings = this._loadings
		, option = this.option
		, url = name
		, type
		, refname
		, fns
		, i
		;
		
		//* add loading callback
		fns = loadings[url] = loadings[url] || [];
		fns.push(fn);
		
		
		//* first loading
		if(fns.length === 1){
			
			//* get type of refname from url
			i = url.indexOf(option.sep);
			if(i > -1){
				type = url.slice(0, i);
				url = url.slice(i + 1);
			}
			
			//* this is refname if type not in type list
			if(typeof type === 'string' && ['module', 'script', 'image', 'text', 'html'].indexOf(type) === -1){
				refname = type;
				type = 'script';
			}
			
			//* auto get type from extname
			if(!type){
				i = url.match(/\.([a-z]{1,5})$/i)
				if(i){
					if(['jpg', 'png', 'svg'].indexOf(i[1].toLowerCase()) > -1){
						type = 'image';
					}
				}
			}
			type = type || 'module';
			
			//* get url beforeLoad method
			i = fnCall(option.beforeLoad, [url, type]);
			if(i){
				url = i;
			}
			
			this._load(url, type, callback);
		}
		
		function callback(rs){
			var item
			;
			if(rs === false){
				throw new Error('loader: load '+ type +' "'+ name +'" error');
			}
			
			if(type === 'module'){
				item = self._parseModule(rs, name);
			}else if(type === 'script'){
				item = self._parseModule(refname);
				item = {
					type: type
					, name: name
					, object: item
				};
			}else{
				item = {
					type: type
					, name: name
					, object: rs
				};
			}
			
			self._setItem(item, name);
			
			each(fns, function(fn){
				fnCall(fn, [item]);
			});
			
			delete loadings[name];
		}
	};
	
	
	
	/**
	 * load url by ajax or script or image
	 * @param {string} name - module name
	 * @param {function} fn - callback
	 * @return {undefined}
	 */
	Loader.prototype._load = function(url, type, fn){
		var pNode
		, node
		;
		
		switch(type){
			case 'image':
				node = new Image();
				node.src = url;
				node.style.cssText = 'width:0;height:0;'
			break; case 'module':
				url = /\.js$/.test(url) ? url : url + '.js';
			break; case 'script':
				node = document.createElement(type);
				node.src = url;
		}
		
		if(node){
			node.setAttribute('loader', '');
			node.onload = function(){
				callback(node);
			}
			
			node.onerror = node.onabort = function(){
				callback();
			}
			
			if(type === 'script'){
				pNode = document.body || document.head || document.documentElement;
				if(!pNode){
					id = 'loader-tmp-' + Math.floor(Math.random() * 10000);
					document.write('<script src="'+ url +'" id="'+ id + '"></script>');
					node = document.getElementById(id)
				}else{
					pNode.appendChild(node);
				}
			}
		}else{
			ajaxGet(url, function(rs){
				callback(rs === false ? false : rs);
			});
		}
		
		function callback(rs){
			if(node && node.tagName === 'IMG'){
				if(node.parentNode){
					//node.parentNode.removeChild(node);
				}
			}
			
			fnCall(fn, [!rs ? false : rs]);
		}
	};
	
	
	Loader.prototype._parseModule = function(content, name){
		var tmpModules = []
		, item
		, rs
		;
		try{
			item = 'var define = function(){tmpModules.push(loader._parseItem.apply(loader, arguments));}, require = typeof require === "function" ? require : loader.get;\n/* === module code start === */\n\nreturn ' + content + '\n\n/* === module code end === */';
			rs = Function('loader', 'tmpModules', item)(this, tmpModules);
		}catch(e){
			throw new Error('loader: parse module "'+ name +'" error');
		}
		
		if(name === undefined){
			item = rs;
		}else{
			item = tmpModules.length ? tmpModules[0] : this._parseItem(name);
		}
		
		return item;
	}
	
	
	/**
	 * export get and set method to object
	 * @param {object} o - target object
	 * @return {undefined}
	 */
	Loader.prototype.exports = function(o){
		var self = this
		;
		o.require = function(){
			return self.get.apply(self, arguments);
		};
		o.define = function(){
			return self.set.apply(self, arguments);
		};
	}
	
	
	
	
	
	
	function typeOf(o){
		return Object.prototype.toString.call(o).slice(8, -1).toLowerCase();
	}
	
	
	function each(o, fn){
		var i
		;
		if(o){
			if(typeof o.length !== 'number'){
				for(i in o){
					if(fn.call(o, o[i], i) === false){
						break;
					}
				}
			}else{
				for(i = 0; i < o.length; i++){
					if(fn.call(o, o[i], i)===false){
						break;
					}
				}
			}
		}
	}
	
	
	function fnCall(fn, args, o){
		if(typeof fn === 'function') return fn.apply(o, args);
	}
	
	
	function ajaxGet(url, fn){
		var xhr = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP")
		;
		xhr.onreadystatechange = function (){
			var rs = false;
			if(typeof fn === 'function' && xhr.readyState === 4){
				if(xhr.status === 200){
					rs = xhr.responseText;
				}
				callback(rs);
			}
		};
		xhr.onerror = function(){
			callback(false);
		};
		
		xhr.open('GET', url, true);
		xhr.send();
		
		function callback(rs){
			typeof fn === 'function' && fn.call(xhr, rs);
		}
	}
	
	
	function exportIt(o, key){
		if(typeof window === 'object' && Object.prototype.toString.call(window) === '[object Window]'){
			key = key || o.name;
			window[key] = o;
		}else{
			module.exports = o;
		}
	}
	
	exportIt(new Loader(), 'loader');
}();